      subroutine SpherHarmDer1(h,f,n,klic)
      include 'fepc.cmn'
      include 'basic.cmn'
      dimension h(3),f(3,(n+1)*(n+1)),xyz(3)
      equivalence (xyz(1),x),(xyz(2),y),(xyz(3),z)
      r=sqrt(h(1)**2+h(2)**2+h(3)**2)
      if(r.lt..001) then
        call SetRealArrayTo(f,3*(n+1)*(n+1),0.)
        go to 9999
      endif
      if(n.ge.0) call SetRealArrayTo(f(1,1),3,0.)
      if(n.ge.1) then
        call CopyVek(h,xyz,3)
        r=sqrt(x**2+y**2+z**2)
        pom=1./r**3
        f(1,2)=        -x*z*pom
        f(2,2)=        -y*z*pom
        f(3,2)= (x**2+y**2)*pom
        f(1,3)= (y**2+z**2)*pom
        f(2,3)=        -x*y*pom
        f(3,3)=        -x*z*pom
        f(1,4)=        -x*y*pom
        f(2,4)= (x**2+z**2)*pom
        f(3,4)=        -y*z*pom
      endif
      if(n.ge.2) then
        pom=1./r**4
        f(1,5)= 2.*x*(  -r**2+x**2+y**2-2.*z**2)*pom
        f(2,5)= 2.*y*(  -r**2+x**2+y**2-2.*z**2)*pom
        f(3,5)= 2.*z*(2.*r**2+x**2+y**2-2.*z**2)*pom
        f(1,6)= z*(1./r**2-2.*x**2*pom)
        f(2,6)=          -2.*x*y*z*pom
        f(3,6)= x*(1./r**2-2.*z**2*pom)
        f(1,7)=          -2.*x*y*z*pom
        f(2,7)= z*(1./r**2-2.*y**2*pom)
        f(3,7)= y*(1./r**2-2.*z**2*pom)
        f(1,8)= ( x/r**2-x*(x**2-y**2)*pom)
        f(2,8)= (-y/r**2-y*(x**2-y**2)*pom)
        f(3,8)=         -z*(x**2-y**2)*pom
        f(1,9)= y*(1./r**2-2.*x**2*pom)
        f(2,9)= x*(1./r**2-2.*y**2*pom)
        f(3,9)=          -2.*x*y*z*pom
      endif
      if(n.ge.3) then
        pom=1./r**5
        f(1,10)= 3.*x*z*(r**2-5.*z**2)*pom
        f(2,10)= 3.*y*z*(r**2-5.*z**2)*pom
        f(3,10)=-3.*(r-z)*(r+z)*(r**2-5.*z**2)*pom
        f(1,11)= (-3*r**2*x**2+3.*x**4-r**2*y**2+3*x**2*y**2
     1          +4.*r**2*z**2-12.*x**2*z**2)*pom
        f(2,11)= x*y*(-2.*r**2+3.*x**2+3.*y**2-12.*z**2)*pom
        f(3,11)= x*z*( 8.*r**2+3.*x**2+3.*y**2-12.*z**2)*pom
        f(1,12)= x*y*(-2.*r**2+3.*x**2+3.*y**2-12.*z**2)*pom
        f(2,12)= (-(r**2*x**2)-3.*r**2.*y**2+3*x**2*y**2+
     1           3.*y**4+4*r**2*z**2-12.*y**2*z**2)*pom
        f(3,12)= y*z*( 8.*r**2+3.*x**2+3.*y**2-12*z**2)*pom
        f(1,13)= x*z*( 2.*r**2-3.*x**2+3.*y**2)*pom
        f(2,13)= y*z*(-2.*r**2-3.*x**2+3.*y**2)*pom
        f(3,13)= (r**2-3.*z**2)*(x-y)*(x+y)*pom
        f(1,14)= 2.*y*z*(r**2-3.*x**2)*pom
        f(2,14)= 2.*x*z*(r**2-3.*y**2)*pom
        f(3,14)= 2.*x*y*(r**2-3.*z**2)*pom
        f(1,15)=-3.*(-r**2*x**2+x**4+r**2*y**2-3*x**2*y**2)*pom
        f(2,15)=-3.*x*y*(2*r**2+x**2-3*y**2)*pom
        f(3,15)=-3.*x*z*(x**2-3*y**2)*pom
        f(1,16)=-3.*x*y*(-2.*r**2+3.*x**2-y**2)*pom
        f(2,16)= 3.*(r**2*x**2-r**2*y**2-3*x**2*y**2+y**4)*pom
        f(3,16)=-3.*y*z*(3.*x**2-y**2)*pom
      endif
      if(n.ge.4) then
        pom=1./r**6
        f(1,17)= x*z**2*(60.-140.*z**2/r**2)/r**4
        f(2,17)= y*z**2*(60.-140.*z**2/r**2)/r**4
        f(3,17)= -60.*z/r**2+200.*z**3/r**4-140.*z**5*pom
        f(1,18)=z*(-3+6*x**2/r**2+7*z**2/r**2-28.*x**2*z**2/r**4)/r**2
        f(2,18)=-2.*x*y*z*(-3*r**2 + 14.*z**2)*pom
        f(3,18)=x*(-3.+27.*z**2/r**2-28.*z**4/r**4)/r**2
        f(1,19)=-2.*x*y*z*(-3.*r**2+14.*z**2)*pom
        f(2,19)=z*(-3.+6.*y**2/r**2+7.*z**2/r**2
     1             -28.*y**2*z**2/r**4)/r**2
        f(3,19)=y*(-3.+27.*z**2/r**2-28.*z**4/r**4)/r**2
        f(1,20)=4.*x*(-r**2*x**2+x**4-y**4+3.*r**2*z**2
     1                -6.*x**2*z**2+6.*y**2*z**2)*pom
        f(2,20)=-4.*y*(-x**4-r**2*y**2+y**4+3*r**2*z**2+6.*x**2*z**2
     1                 -6.*y**2*z**2)*pom
        f(3,20)=4.*z*(x-y)*(x+y)*(3.*r**2+x**2+y**2-6.*z**2)*pom
        f(1,21)=y*(-6.*x**2+8.*x**4/r**2-2.*y**2+8.*x**2*y**2/r**2
     1             +12.*z**2-48.*x**2*z**2/r**2)/r**4
        f(2,21)=x*(-2.*x**2-6.*y**2+8.*x**2*y**2/r**2+8.*y**4/r**2
     1             +12.*z**2-48.*y**2*z**2/r**2)/r**4
        f(3,21)= 8.*x*y*z*(3.*r**2+x**2+y**2-6.*z**2)*pom
        f(1,22)=z*(3.*x**2-3.*y**2)/r**4-4.*x*z*(x**3-3.*x*y**2)*pom
        f(2,22)=-2.*x*y*z*(3.*r**2+2.*x**2-6.*y**2)*pom
        f(3,22)=x*(r**2-4.*z**2)*(x**2-3.*y**2)*pom
        f(1,23)= -2.*x*y*z*(-3.*r**2+6.*x**2-2.*y**2)*pom
        f(2,23)=z*(3.*r**2*x**2-3.*r**2*y**2-12.*x**2*y**2+4.*y**4)*pom
        f(3,23)= -y*((r**2-4.*z**2)*(-3.*x**2+y**2)*pom)
        f(1,24)=-4.*x*(-(r**2*x**2)+x**4+3.*r**2*y**2-6.*x**2*y**2
     1                +y**4)*pom
        f(2,24)=-4.*y*(3.*r**2*x**2+x**4-r**2*y**2
     1                 -6.*x**2*y**2+y**4)*pom
        f(3,24)=-4.*z*(x**4-6.*x**2*y**2+y**4)*pom
        f(1,25)=-4.*y*(-3.*r**2*x**2+4.*x**4+r**2*y**2-4.*x**2*y**2)*pom
        f(2,25)= 4.*x*(r**2*x**2-3.*r**2*y**2-4.*x**2*y**2+4.*y**4)*pom
        f(3,25)=-16.*x*y*z*(x-y)*(x+y)*pom
      endif
      if(n.ge.5) then

      endif
      if(n.ge.6) then

      endif
      if(n.ge.7) then

      endif
      if(Klic.eq.1) then
        do i=1,(n+1)**2
          do j=1,3
            f(j,i)=f(j,i)*Clm(i)
          enddo
        enddo
      else if(Klic.eq.2) then
        do i=1,(n+1)**2
          do j=1,3
            f(j,i)=f(j,i)*Mlm(i)
          enddo
        enddo
      else if(Klic.eq.3) then
        do i=1,(n+1)**2
          do j=1,3
            f(j,i)=f(j,i)*Llm(i)
          enddo
        enddo
      endif
9999  return
      end
